#include <stdbool.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include "NcString.h"

void StringEscapeBuf(const char * s, char * d)
{
	char c;
	while ((c = *(s++)) != 0)
	{
		switch (c)
		{
		case '\a':
			*(d++) = '\\';
			*(d++) = 'a';
			break;
		case '\b':
			*(d++) = '\\';
			*(d++) = 'b';
			break;
		case '\t':
			*(d++) = '\\';
			*(d++) = 't';
			break;
		case '\n':
			*(d++) = '\\';
			*(d++) = 'n';
			break;
		case '\v':
			*(d++) = '\\';
			*(d++) = 'v';
			break;
		case '\f':
			*(d++) = '\\';
			*(d++) = 'f';
			break;
		case '\r':
			*(d++) = '\\';
			*(d++) = 'r';
			break;
		case '\\':
			*(d++) = '\\';
			*(d++) = '\\';
			break;
		case '\"':
			*(d++) = '\\';
			*(d++) = '\"';
			break;
		default:
			*(d++) = c;
		}
	}
	*d = '\0';
}

void StringUnEscapeBuf(const char * s, char * d)
{
	char c;
	bool esc = false;
	while ((c = *(s++)) != 0)
	{
		if (c!='\\' && !esc)
		{
			*(d++) = c;
			continue;
		}
		if (c=='\\' && !esc)
		{
			esc = true;
			continue;
		}
		switch (c)
		{
			case 'a':
				*(d++) = '\a';
				break;
			case 'b':
				*(d++) = '\b';
				break;
			case 't':
				*(d++) = '\t';
				break;
			case 'n':
				*(d++) = '\n';
				break;
			case 'v':
				*(d++) = '\v';
				break;
			case 'f':
				*(d++) = '\f';
				break;
			case 'r':
				*(d++) = '\r';
				break;
			case '\\':
				*(d++) = '\\';
				break;
			case '"':
				*(d++) = '\"';
				break;
			default:
				*(d++) = '\\';
				*(d++) = c;
		}
		esc = false;
	}
	*d = 0;
}

char * StringEscape(const char * s)
{
	char * d = (char*)malloc( 2*strlen(s) + 1 );
	if (d==NULL) return NULL;
	StringEscapeBuf(s, d);
	return d;
}

char * StringUnEscape(const char * s)
{
	char * d = (char*)malloc( strlen(s) + 1 );
	if (d==NULL) return NULL;
	StringUnEscapeBuf(s, d);
	return d;
}
