#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "NcApi.h"
#include "NcApiImpl.h"
#include "RecvTask.h"
#include "SendTask.h"

tNcApi g_ncApi[1];
uint8_t g_numberOfNcApis = 1;
tNcApiRxHandlers g_ncRx;

extern SendState g_send;

void NcApiTxData(uint8_t n, uint8_t * finalMsg, uint8_t finalMsgLength)
{
	// dummy, the posix write is declared with __WUR
	ssize_t dummy = write(g_send.fd, finalMsg, finalMsgLength);
	(void) dummy;
}

void NcApiMessageWrittenCallback(uint8_t n, void * callbackToken, uint8_t * finalMsg, uint8_t finalMsgLength)
{
	uint16_t i;
	printf("Raw UART data sent: ");
	for (i=0; i<finalMsgLength; i++)
		printf( "%02x ", finalMsg[i] );
	printf("\r\n");
	g_send.msgWasWritten = true;
}



void NcApiMessageReceived(uint8_t n,void * callbackToken, uint8_t * msg, uint8_t msgLength)
{
	NcApiExecuteCallbacks(n,msg,msgLength);
}


bool SetupNcApi()
{
	tNcApiRxHandlers * h = &g_ncRx;
	memset( h, 0, sizeof(tNcApiRxHandlers));
	h->pfnReadCallback = UartReadCallback;
	h->pfnHostAckCallback = UartHostAckCallback;
	h->pfnHostNAckCallback = UartHostNAckCallback;
	h->pfnHostDataCallback = UartHostDataCallback;
	h->pfnHostDataHapaCallback = UartHostDataHapaCallback;
	h->pfnWesStatusCallback = UartWesStatusCallback;
	h->pfnWesRequestCallback = UartWesRequestCallback;
	NcApiInit();
	
	g_ncApi[0].NcApiRxHandlers=&g_ncRx;
	
	return true;
}

#ifdef DEBUG
#ifdef __cplusplus
extern "C"
{
#endif
void __error__(char *pcFilename, uint32_t ui32Line)
{
	printf("ERROR: %s (%d)", pcFilename, ui32Line);
	exit(EXIT_FAILURE);
}
#ifdef __cplusplus
}
#endif
#endif//DEBUG
