#ifndef SENDTASK_H_
#define SENDTASK_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include "Configuration.h"
#include "NcApi.h"
#include "NeoParser.h"
#include "NcSocket.h"

typedef struct tSendState
{
	int fd;
	tSendConfig * config;
	volatile TaskRunEnum state;
	int socketFd;
	struct sockaddr_in address;
	int clientFd;
	uint8_t * clientRaw;
	int clientRawLen;
	char * clientMsg;
	int clientMsgLen;
	tNcApiSendParams ncSendParams;
	tNcApiAltCmdParams ncAltCmd;
	tNcApiWesCmdParams ncWesCmd;
	tNcApiWesResponseParams ncWesResponse;
	NcApiMessageType ncApiType;
	volatile bool msgWasWritten;
} SendState;

// Task specific methods
bool SendTaskInit(void * p);
void* SendTaskRun(void * p);
bool SendTaskShutdown();

#ifdef __cplusplus
}
#endif



#endif /* SENDTASK_H_ */
