#ifndef SERIALIZATION_H_
#define SERIALIZATION_H_

#include "NcApi.h"
#include "Messages.h"

typedef class tSerializer
{
public:
	virtual ~tSerializer() {}
	virtual const char * SerializeAck(tNcApiHostAck * p) = 0;
	virtual const char * SerializeNAck(tNcApiHostAck * p) = 0;
	virtual const char * SerializeRaw(uint8_t * Buffer,uint8_t payloadLength) = 0;
	virtual const char * Serialize(tNcApiHostData * p) = 0;
	virtual const char * Serialize(tNcApiHostDataHapa * p) = 0;
	virtual const char * Serialize(tNcApiWesRequest * p) = 0;
	virtual const char * Serialize(tNcApiWesStatus * p) = 0;
	virtual const char * Serialize(ReplyMsg * p) = 0;

	virtual const char * DeSerialize(const char * m, int len, SendMsg * msg) = 0;
	virtual const char * DeSerialize(const char * m, int len, tNcApiWesCmd * msg) = 0;
	virtual const char * DeSerialize(const char * m, int len, tNcApiAltCmd * msg) = 0;
	virtual const char * DeSerialize(const char * m, int len, tNcApiWesResponse * msg) = 0;
} ISerializer;

#endif /* SERIALIZATION_H_ */
